#pragma once

// Only include FlexLexer.h if it hasn't been already included
#if ! defined(yyFlexLexerOnce)
#include <FlexLexer.h>
#endif

// Override the interface for yylex since we namespaced it
#undef YY_DECL
#define YY_DECL int parser::FlexScanner::yylex()

/* before, in Driver.h, it was (from Berni):
#define YY_DECL                                \
 yy::Parser::token_type                        \
 yylex(yy::Parser::semantic_type* yylval,      \
       yy::Parser::location_type* yylloc)
YY_DECL;
*/


// Include Bison for types / tokens
#include "parser.hh"


namespace parser {
	class FlexScanner : public yyFlexLexer {
		public:
			FlexScanner(FLEX_STD istream* in = 0, FLEX_STD ostream* out = 0) : yyFlexLexer(in, out) { }
			
			// save the pointer to yylval so we can change it, and invoke scanner
			int yylex(parser::Parser::semantic_type * lval, parser::Parser::location_type* lloc) { yylval = lval; yylloc=lloc; return yylex(); }
		
		private:
			// Scanning function created by Flex; make this private to force usage
			// of the overloaded method so we can get a pointer to Bison's yylval and yylloc
			int yylex();
			
			// point to yylval (provided by Bison in overloaded yylex)
			parser::Parser::semantic_type * yylval;
			// point to yylloc
			parser::Parser::location_type* yylloc;
	};
}

